/*
Fondamenti di Informatica e Laboratorio
Ingegneria Telematica
Esame del 04/02/2008
compito i3
Tempo a disposizione: 2h 30 min

Scrivere un programma per la gestione dei dipendenti e delle attivit di un'azienda.
I dipendenti sono caratterizzati dalle seguenti informazioni: Nome, Cognome, numero di matricola, data di assunzione, tipo di qualifica.
I dipendenti sono inseriti in una tabella allocata dinamicamente avente 6 righe, una  per ogni tipo di qualifica.
Ai dipendenti pu essere assegnato un compito da svolgere un certo giorno della settimana.
Ogni compito  caratterizzato dalle seguenti informazioni: numero di matricola, giorno della settimana, codice attivit. I compiti vengono inseriti in un vettore di 5 liste, una per ogni giorno lavorativo della settimana.
Ogni lista  ordinata rispetto al codice attivit.
Nel programma e' presente un men caratterizzato dalle seguenti funzioni:
1.Inserimento nella tabella di un nuovo dipendente;
2.Eliminazione di un dipendente dopo averne visualizzato il cognome e nome;
3.Inserimento nel vettore di liste di un nuovo compito per un dipendente dopo avere verificato la presenza del dipendente in tabella;
4.Visualizzazione dei compiti relativi a un certo giorno.

Liberare la memoria allocata dinamicamente.

*/
#include <stdio.h>
#include <stdlib.h>

typedef struct{
	int matricola,codice;
	int giorno;
}compito;


struct atomo{
	compito dato;
	struct atomo *next;
};

typedef struct{
	char nome[30],cognome[30],data[11];
	int matricola,tipo;
}dipendente;



void ins_tabella(dipendente *T[6], int *N);
void elimina_tabella(dipendente *T[6], int *N);
void leggi(compito *s);
void ins_ordinato(dipendente *T[6], int *N, struct atomo *tl[5]);
void vis_lista(struct atomo *tl[5]);
void libera_liste(struct atomo **tl);
void menu();

main() {
	struct atomo *LC[5];
	compito s;
	dipendente *TD[6];
	int N[4],opz,i,tessera;


	for(i=0;i<4;i++)
		{	TD[i]=NULL;
			N[i]=0;
		}

	for(i=0;i<5;i++)
		LC[i]=NULL;

	do{	menu();
		scanf("%d",&opz);
		switch(opz){
			case 1: ins_tabella(TD,N);
					break;
			case 2: elimina_tabella(TD,N);
					break;
			case 3: ins_ordinato(TD,N, LC);
					break;
			case 4: vis_lista(LC);
					break;

			default:;
		}
	}while(opz!=0);

	for(i=0;i<5;i++)
		libera_liste(&LC[i]);
	for(i=0;i<6;i++)
		free(TD[i]);
}


void leggi(compito *s)
{
	printf("Inserisci la matricola: ");
	scanf("%d",&s->matricola);
	printf("Inserisci il codice attivita': ");
	scanf("%d",&s->codice);
	printf("Inserisci il giorno della settimana (0,..,4): ");
	scanf("%d",&s->giorno);
}

void ins_ordinato(dipendente *TD[6], int *N, struct atomo *TL[5])

{
    compito s;
	struct atomo *aux, *l1,*l2;
    int tipo,matricola;
	int i,g;

	leggi(&s);
	printf("Inserisci il tipo di qualifica");
	scanf("%d",&tipo);
	/* ricerca */

	for(i=0;i<N[tipo];i++)
		if(TD[tipo][i].matricola==s.matricola)
			break;
    if(i==N[tipo])
		{ 	printf("Non trovato \n");
			return;
	    }

	aux=malloc(sizeof(struct atomo));
	if(aux==NULL) return;
	aux->dato=s;

	g=s.giorno;
	if(TL[g]==NULL || s.codice<TL[g]->dato.codice)
		{	aux->next=TL[g];
			TL[g]=aux;
			return;
		}
	l2=TL[g];
	l1=l2->next;

	while(l1!=NULL)
		{	if(s.codice<l1->dato.codice)
				break;
			else { l2=l1;
					l1=l1->next;
				 }
		}

	l2->next=aux;
	aux->next=l1;
}



void vis_lista(struct atomo *tl[5])
{
	int giorno;
	struct atomo *aux;

	printf("Inserisci il giorno della settimana (0,..,4)\n");
	scanf("%d",&giorno);

	aux=tl[giorno];
	while(aux!=NULL)
		{	printf("Matricola %d\n",aux->dato.matricola);
			printf("Codice attivita': %d\n",aux->dato.codice);
			aux=aux->next;
		}


}




void ins_tabella(dipendente *T[4], int *N)
{
	int p,i,tipo;
	struct atomo *aux;
	dipendente d,*R;

	printf("\nNome: ");
	scanf("%s", d.nome);
	printf("\nCognome: ");
	scanf("%s", d.cognome);
	printf("\nMatricola: ");
	scanf("%d", &d.matricola);
	printf("\nTipo di qualifica: ");
	scanf("%d", &d.tipo);
	printf("\nData: ");
	scanf("%s", d.data);

    tipo=d.tipo;
	R=realloc(T[tipo],sizeof(dipendente)*(N[tipo]+1));
	if(R==NULL) return;
    T[tipo]=R;

	T[tipo][N[tipo]]=d;
	N[tipo]++;
}


void elimina_tabella(dipendente *T[4], int *N)
{
	int i,p,tipo,matricola;


	printf("Inserisci il tipo di qualifica\n");
	scanf("%d",&tipo);
	printf("Inserisci la matricola\n");
	scanf("%d",&matricola);
	/* Ricerca */
	for(p=0;p<N[tipo];p++)
		if(T[tipo][p].matricola==matricola)
			break;

	if(p==N[tipo])  /* Non trovato*/
		return;


	/* Trovato, dunque stampo ed elimino */
	printf("Cognome: %s\n",T[tipo][p].cognome);
	printf("Nome: %s\n",T[tipo][p].nome);

	for(i=p;i<N[tipo]-1;i++)
		T[tipo][i]=T[tipo][i-1];
	N[tipo]--;
	T[tipo]=realloc(T[tipo],sizeof(dipendente)*N[tipo]);
}

void libera_liste(struct atomo **tl)
{
	struct atomo *aux;
	while(*tl!=NULL)
		{	aux=*tl;
			*tl=aux->next;
			free(aux);
		}
}
void menu(){
	printf("Scegli tra\n");
	printf("1) Inserimento di una dipendente\n");
	printf("2) Elimina un dipendente\n");
	printf("3) Inserimento in lista di un compito\n");
	printf("4) Visualizza una lista\n");
	printf("0) Esci\n\n");
}
